#include <Servo.h>

Servo servo[3]; //서보모터 객체 생성

//서보모터 신호선(주황색) 연결 핀 번호
int pin[3] = {8, 7, 6}; //8 상하, 7 좌우, 6 발사
//서보모터 초기 각도 
int initAngle[3] = {80, 100 , 20};

//서보모터 관련 배열 선언
int idle[3], currentAngle[3];
//각도 범위-좌우(175~15), 상하(120~60), 발사(20~170)
int MAX[3] = {120, 164, 170}, MIN[3] = {60, 4, 20};

//조이스틱 관련 배열 및 변수 선언
int value[3], ANA[2] = {A1, A0} ; 
int btn = 5;

void setup() {
  //서보모터 핀 설정 및 각 배열 초기화
  for(int i=0; i<3; i++){
    servo[i].attach(pin[i]);
    servo[i].write(initAngle[i]);
    value[i] = 0;
    idle[i] = 0;
  }
  //조이스틱 버튼 핀 모드 및 초기화
  pinMode(btn, INPUT);
  digitalWrite(btn, HIGH);
}

void loop() {
  delay(30);
  int btnValue = digitalRead(btn); //버튼 값 읽기
  for (int i = 0; i < 2; i++){
      value[i] = analogRead(ANA[i]); //조이스틱 축 값 읽기
      //서보모터 현재 각 읽어서 저장하기
      currentAngle[i] = servo[i].read();

      //x, y 축의 조이스틱 값이 612 이상이면?
      if (value[i] > 612) {
        idle[i] = 0;
        //각 서보모터의 설정된 최대값보다 작다면?
        if (currentAngle[i] < MAX[i]){
          //각도 +1
          ++currentAngle[i];
        }
        //서보모터가 연결된 상태가 아니라면?
        if (!servo[i].attached()){
          //서보모터 핀 설정
          servo[i].attach(pin[i]);
        }
        //서보모터 각도 설정
        servo[i].write(currentAngle[i]);     
      } else if (value[i] < 412) {
        idle[i] = 0;
        if (currentAngle[i] > MIN[i]){
          --currentAngle[i];
        }
        if (!servo[i].attached()){
          servo[i].attach(pin[i]);
        }
      servo[i].write(currentAngle[i]);    
    } else {
      //조이스틱을 동작하지 않고 있다면 idle 배열 +1
      ++idle[i];
    }
    if (idle[i] > 100){
       //서보모터를 일정시간 사용하지 않으면 연결을 끊기
      servo[i].detach();
      idle[i] = 0;
    }  
  }
  //조이스틱 버튼을 눌렀을 경우?
  if(btnValue == LOW){
    servo[2].write(MAX[2]);
    for(int i=MAX[2]; i>=MIN[2]; i--){
      servo[2].write(i);
      delay(5);
    }
  }
}
